/*
 *    (c) Copyright Motorola 2003 All rights reserved.
 *     Motorola Confidential Proprietary
 *     Contains confidential proprietary information of Motorola, Inc.
 *     Reverse engineering is prohibited.
 *     The copyright notice does not imply publication.
 *            
 *     DESCRIPTION:
 *       Support E680 Network && BT indicator LED.
 *     REVISION HISTORY:
 *         Date        Author                      Reference
 *      --------    --------            --------------------------
 *     12/10/2003  Liu weijie A19553      Create     
 *     
 ********/

#ifndef LED_PXA_E680_H
#define LED_PXA_E680_H

#include <linux/led.h>

enum
{
LED_OFF = 0,

LED_RED_ALWAYS_ON,
LED_GREEN_ALWAYS_ON,
LED_BLUE_ALWAYS_ON,
LED_LIGHT_RED_ALWAYS_ON,
LED_ORANGE_ALWAYS_ON,
LED_LIGHT_BLUE_ALWAYS_ON,
LED_WHITE_ALWAYS_ON,

LED_RED_01_ON_19_OFF,
LED_RED_02_ON_18_OFF,
LED_RED_05_ON_15_OFF,
LED_RED_025_ON_075_OFF,
LED_RED_025_ON_175_OFF,
LED_RED_005_ON_195_OFF,
LED_RED_05_ON_05_OFF,
LED_RED_05_OFF_05_ON,
LED_RED_0125_ON_05_OFF_0075_ON_15_OFF,
LED_RED_0125_ON_2075_OFF,
LED_RED_0625_OFF_0075_ON_15_OFF,

LED_RED_01_ON_19_OFF_SKIP,
LED_RED_02_ON_18_OFF_SKIP,
LED_RED_05_ON_15_OFF_SKIP,
LED_RED_025_ON_075_OFF_SKIP,
LED_RED_025_ON_175_OFF_SKIP,
LED_RED_005_ON_195_OFF_SKIP,
LED_RED_05_ON_05_OFF_SKIP,
LED_RED_05_OFF_05_ON_SKIP,
LED_RED_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_RED_0125_ON_2075_OFF_SKIP,
LED_RED_0625_OFF_0075_ON_15_OFF_SKIP,

LED_GREEN_01_ON_19_OFF,
LED_GREEN_02_ON_18_OFF,
LED_GREEN_05_ON_15_OFF,
LED_GREEN_025_ON_075_OFF,
LED_GREEN_025_ON_175_OFF,
LED_GREEN_005_ON_195_OFF,
LED_GREEN_05_ON_05_OFF,
LED_GREEN_05_OFF_05_ON,
LED_GREEN_0125_ON_05_OFF_0075_ON_15_OFF,
LED_GREEN_0125_ON_2075_OFF,
LED_GREEN_0625_OFF_0075_ON_15_OFF,

LED_GREEN_01_ON_19_OFF_SKIP,
LED_GREEN_02_ON_18_OFF_SKIP,
LED_GREEN_05_ON_15_OFF_SKIP,
LED_GREEN_025_ON_075_OFF_SKIP,
LED_GREEN_025_ON_175_OFF_SKIP,
LED_GREEN_005_ON_195_OFF_SKIP,
LED_GREEN_05_ON_05_OFF_SKIP,
LED_GREEN_05_OFF_05_ON_SKIP,
LED_GREEN_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_GREEN_0125_ON_2075_OFF_SKIP,
LED_GREEN_0625_OFF_0075_ON_15_OFF_SKIP,

LED_BLUE_01_ON_19_OFF,
LED_BLUE_02_ON_18_OFF,
LED_BLUE_05_ON_15_OFF,
LED_BLUE_025_ON_075_OFF,
LED_BLUE_025_ON_175_OFF,
LED_BLUE_005_ON_195_OFF,
LED_BLUE_05_ON_05_OFF,
LED_BLUE_05_OFF_05_ON,
LED_BLUE_0125_ON_05_OFF_0075_ON_15_OFF,
LED_BLUE_0125_ON_2075_OFF,
LED_BLUE_0625_OFF_0075_ON_15_OFF,

LED_BLUE_01_ON_19_OFF_SKIP,
LED_BLUE_02_ON_18_OFF_SKIP,
LED_BLUE_05_ON_15_OFF_SKIP,
LED_BLUE_025_ON_075_OFF_SKIP,
LED_BLUE_025_ON_175_OFF_SKIP,
LED_BLUE_005_ON_195_OFF_SKIP,
LED_BLUE_05_ON_05_OFF_SKIP,
LED_BLUE_05_OFF_05_ON_SKIP,
LED_BLUE_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_BLUE_0125_ON_2075_OFF_SKIP,
LED_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,

LED_ORANGE_01_ON_19_OFF,
LED_ORANGE_02_ON_18_OFF,
LED_ORANGE_05_ON_15_OFF,
LED_ORANGE_025_ON_075_OFF,
LED_ORANGE_025_ON_175_OFF,
LED_ORANGE_005_ON_195_OFF,
LED_ORANGE_05_ON_05_OFF,
LED_ORANGE_05_OFF_05_ON,
LED_ORANGE_0125_ON_05_OFF_0075_ON_15_OFF,
LED_ORANGE_0125_ON_2075_OFF,
LED_ORANGE_0625_OFF_0075_ON_15_OFF,

LED_ORANGE_01_ON_19_OFF_SKIP,
LED_ORANGE_02_ON_18_OFF_SKIP,
LED_ORANGE_05_ON_15_OFF_SKIP,
LED_ORANGE_025_ON_075_OFF_SKIP,
LED_ORANGE_025_ON_175_OFF_SKIP,
LED_ORANGE_005_ON_195_OFF_SKIP,
LED_ORANGE_05_ON_05_OFF_SKIP,
LED_ORANGE_05_OFF_05_ON_SKIP,
LED_ORANGE_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_ORANGE_0125_ON_2075_OFF_SKIP,
LED_ORANGE_0625_OFF_0075_ON_15_OFF_SKIP,

LED_RED_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF,
LED_GREEN_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF,
LED_ORANGE_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF,

LED_RED_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,
LED_GREEN_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,
LED_ORANGE_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,

LED_BOTTOM_STATE
};

#define LED_E680_NAME "LED_E680_INDICATOR"

#endif /* LED_PXA_E680_H*/

